/*
Copyright Charles Emile HUBERT / Renaud GICQUEL 2005  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import extThopt.*;
import java.util.*; 
import java.awt.*; 
import javax.swing.*;

/**
 * classe de calcul du rcteur PROX
 * 
 * @author CE HUBERT
 */
public class Prox extends ExtProcess
{
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JTextField xi_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JTextField xi2_value = new javax.swing.JTextField();
    
    double Tamont, Taval, Pamont, Paval,Hamont;
    Vector inputComp;
    Vector outputComp;
    double Fh2,Fco2,Fh2o,Fn2,Fch4,Fco,Fo2,F0,Ftot,Fcoin,Fo2in,FAr;
    double xi1, xi2, O2CO;
    
    public Prox (){
        super();
		JPanel1.setLayout(null);
		JPanel1.setBounds(0,0,400,300);
		JLabel1.setText("xi");
		JLabel1.setForeground(Color.blue);
		JPanel1.add(JLabel1);
		JLabel1.setBounds(0,0,60,20);
		JPanel1.add(xi_value);
		xi_value.setBounds(164,0,124,20);
		xi_value.setText("0.99");
		JLabel5.setText("xi2");
		JLabel5.setForeground(Color.blue);
		JPanel1.add(JLabel5);
		JLabel5.setBounds(0,24,60,20);
		JPanel1.add(xi2_value);
		xi2_value.setBounds(164,24,124,20);
		xi2_value.setText("0.98");

		JLabel2.setText("");
		JPanel1.add(JLabel2);
		JLabel2.setBounds(0,48,400,20);
		
		JLabel3.setText("");
		JPanel1.add(JLabel3);
		JLabel3.setBounds(0,72,400,20);
		
		JLabel4.setText("");
		JPanel1.add(JLabel4);
		JLabel4.setBounds(0,96,400,20);
		type=getCompType();
   		thermoCouplerTypes=new String[1];//no thermocoupler connected
		thermoCouplerTypes[0]="water cooling";
    }
    
    public String getType(){
        return "PROX";
    }
    public String getCompType(){
        return "PROX";
    }
    
  	public String getClassDescription(){
	    return "Prox reactor (without thermocoupler)\n\nauthor : CE Hubert, R. Gicquel  march 2005\n\nRef : ??";
	}

	
	public void init(){
	    calculateProcess();
    }
	
	public void calculateProcess(){
        String[] args=new String[2];
        args[0]="process";//type of the element (see method getProperties(String[] args))
        args[1]=tfe.getCompName();//name of the process (see method getProperties(String[] args))
        Vector vProp=proj.getProperties(args);
        Double f=(Double)vProp.elementAt(3);
        double flow=f.doubleValue();
        String amont=(String)vProp.elementAt(1);//gets the upstream point name
        String aval=(String)vProp.elementAt(2);//gets the downstream point name
        getPointProperties(amont);//direct parsing of point property vector
        Tamont=Tpoint;
        Pamont=Ppoint;
        Hamont=Hpoint;
        getSubstProperties(nomCorps);
        F0=flow/Msubst;
       
        if(typeSubst==4){//le corps d'entre est un gaz compos
            
            //initialisations pour la dtermination de la raction
            inputComp=lecorps.getGasComposition();
            //outputComp=lecorps.getGasComposition();//le gaz aval aura les mmes composants que le gaz amont
                        
	        Fh2=F0*Util.molarComp(inputComp,"H2");
            Fco2=F0*Util.molarComp(inputComp,"CO2");
            Fh2o=F0*Util.molarComp(inputComp,"H2O");
            Fch4=F0*Util.molarComp(inputComp,"CH4 ` mthane");
            Fn2=F0*Util.molarComp(inputComp,"N2");
            Fco=F0*Util.molarComp(inputComp,"CO");
            Fo2=F0*Util.molarComp(inputComp,"O2");
            FAr=F0*Util.molarComp(inputComp,"Ar");
            
           	O2CO=Fo2/Fco;
	     	
	     	System.out.println("Fh2 entre prox : "+Fh2);
	     	        	        
	        if(Fco*Fo2!=0){//le gaz en entre contient CO et O2
	 
				if(Fo2>=0.5*Fco){//il y a assez d'O2 pour oxyder le CO
	 
            	Fcoin=Fco;
		   		Fo2in=Fo2;
            
         	   // calcul des dbits molaires en sorties
       	     
      //	      	xi1=0.99; // avancement de la raction (1)
      // 	    	xi2=0.98; // avancement de la raction (2) 
      	   	    
      	   	    xi1=Util.lit_d(xi_value.getText());
      	   	    xi2=Util.lit_d(xi2_value.getText());
      	   	    
     	   	    Fh2=Fh2-2*(1.-xi2)*(Fo2-xi1/2*Fco);
        	    Fco2=Fco2+xi1*Fco;
        	    Fh2o=Fh2o+2*(1.-xi2)*(Fo2-xi1/2*Fco);
     		    Fo2=(Fo2-xi1/2*Fco)*(1-xi2);
         		Fco=Fco*(1-xi1);
     			Ftot = Fh2 + Fco2 + Fh2o + Fch4 + Fn2 + Fco + Fo2 +FAr;
     		
     	        System.out.println("Fh2 sortie prox : "+Fh2);
     	        
     	        }
             	 
             	else{//le gaz en entre ne contient pas assez d'O2 pout oxyder le CO
	            String msg = "Error PROX: the inlet gas does not include enought O2";
	            JOptionPane.showMessageDialog(tfe, msg);  
	        	}        
	      	}
	      	else{//le gaz en entre ne contient pas de CO ou pas de O2
	        String msg = "Error PROX: the inlet gas does not include CO or O2";
	        JOptionPane.showMessageDialog(tfe, msg);  
	        }
	    }
	    else{//le corps d'entre n'est pas un gaz compos
	        String msg = "Error PROX: the inlet substance is not a compound gas";
	        JOptionPane.showMessageDialog(tfe, msg);  
	    }
            
            // Composition molaire des produits

	        
	        double xH2=Fh2/Ftot;
	        double xCO2=Fco2/Ftot;
	        double xH2O=Fh2o/Ftot;
	        double xN2=Fn2/Ftot;
	        double xCH4=Fch4/Ftot;
	        double xCO=Fco/Ftot;
	        double xO2=Fo2/Ftot;
	        double xAr=FAr/Ftot;

            //mise  jour de la composition du corps aval
	        
	        outputComp=new Vector();
                int nComp=8;
                if(xO2==0)nComp=7;
                String[] Comp= new String[nComp];
                Double[]fracMol= new Double[nComp];
                Double[]fracMass= new Double[nComp];
                Comp[0]="H2";Comp[1]="CO2";Comp[2]="H2O";Comp[3]="CH4 ` mthane";Comp[4]="N2";Comp[5]="CO";Comp[6]="Ar";
                if(xO2!=0)Comp[7]="O2";
	        
	       		fracMol[0]=new Double(xH2);
                fracMol[1]=new Double(xCO2);
                fracMol[2]=new Double(xH2O);
                fracMol[3]=new Double(xCH4);
                fracMol[4]=new Double(xN2);
                fracMol[5]=new Double(xCO);
                fracMol[6]=new Double(xAr);
                if(xO2!=0)fracMol[7]=new Double(xO2);
                
                fracMass[0]=new Double(xH2O);
                fracMass[1]=new Double(xCO2);
                fracMass[2]=new Double(xH2);
                fracMass[3]=new Double(xCH4);
                fracMass[4]=new Double(xN2);
                fracMass[5]=new Double(xCO);
                fracMass[6]=new Double(xAr);
                if(xO2!=0)fracMass[7]=new Double(xO2);
                
                outputComp.addElement(new Integer(nComp));
                outputComp.addElement(Comp);
                outputComp.addElement(fracMol);
                outputComp.addElement(fracMass);
                outputComp.addElement(new Double(1.));
                
             //System.out.println("T point avant : "+Tpoint);
      
             getPointProperties(aval);//direct parsing of point property vector (rcupre en particulier le nom du corps en question
             getSubstProperties(nomCorps);
 	       	 lecorps.updateGasComposition(outputComp); //mise  jour de la composition du gaz en sortie
 	       	 tfe.setupPointAval(getProperties());//mise  jour de la transfo et du point aval
 	       	 	        
             
            //calcul de la temprature du point aval
            double Q_mol=(Fcoin*xi1*282.7+(Fo2in-(1.-xi2)*(2*Fcoin-Fcoin*xi1))*240.65)/F0;//chaleur libre par mol de gaz entrant (enthalpies de raction  60 C)
            double Q_mass=Q_mol/Msubst*1000;//chaleur libre par kg de gaz entrant
	        double h_out=Hamont+Q_mass; // enthalpie massique du mlange sortant
	        Tpoint=Tamont;
	        updateThermoCoupler("water cooling", Tamont, Tamont, -Q_mass, flow,true,10);
	        
	        getSubstProperties(nomCorps);
	       	tfe.setupPointAval(getProperties());//mise  jour de la transfo et du point aval
	    	
	    	JLabel2.setText("ratio O2/CO = "+Util.aff_d(O2CO,2)+"  ;  limite infrieure thorique: O2/CO =0.5");
	        //JLabel2.setText("F_in="+Util.aff_d(F0,4)+" mol/s ; F_out="+Util.aff_d(Ftot,4)+" mol/s");
	        JLabel3.setText("xi1 = "+Util.aff_d(xi1,4)+"              xi2 = "+Util.aff_d(xi2,4)+" ; CO_out="+Util.aff_d(xCO*1000000,1)+" ppm");
			JLabel4.setText("F_H2_in="+Util.aff_d(F0*Util.molarComp(inputComp,"H2"),5)+" mol/s ; F_H2_out="+Util.aff_d(Ftot*xH2,5)+" mol/s");
	}
	
		public void readCompParameters(String ligne_data){
        String valeur=Util.extr_value(ligne_data, "xi_value");
        if(valeur!=null)xi_value.setText(valeur);
        valeur=Util.extr_value(ligne_data, "xi2_value");
        if(valeur!=null)xi2_value.setText(valeur);
	}
	
    public String saveCompParameters(){
	    String h="";
	    h=h
	    +"xi_value="+xi_value.getText()+tab
	    +"xi2_value="+xi2_value.getText()+tab
	    ;
        return h;
    }

 }
 